# nano-keras

## Overview

### **nano-keras** is a compact implementation of [Keras](https://keras.io/) using only Python and NumPy. It's designed with the primary aim of deepening understanding about neural network fundamentals and their implementation at a lower level. While it might not match the speed or feature-rich capabilities of Keras, it serves as an educational project to explore the inner workings of neural networks

## Key Features

### - Simplicity: Built using fundamental Python and NumPy functionalities, emphasizing simplicity and readability

### - Educational: Intended as a learning tool to understand neural network components at a lower level

### - Customization: Allows for tinkering and understanding the core mechanics of neural network operations

## What you can find in nano-keras

### Layers: Input, Dense, Dropout, Flatten, Reshape, MaxPool1D/2D, Conv1D/2D

### Optimizers: SGD, Adam, Adadelta, Adagrad, RMSProp, NAdam

### Activation functions: Sigmoid, Tanh, ReLU, ELU, LeakyReLU, Softmax

### Loss functions: MAE, MSE, BCE, CCE, Hinge, Huber

### Callbacks: EarlyStopping, LearningRateScheduler, CSVLogger

### And much more, you can find all the implemented items in [here](https://github.com/MarcelWinterot/nano-keras/wiki/Roadmap)

## Instalation

### **nano-keras** is available on [PyPI](https://pypi.org/project/nano-keras/) so in order to download it open a terminal and paste:

```bash
pip install nano-keras
```

### You now should have succesfully installed nano-keras so to use it in your python file you only need to import it like this:

```py
import nano_keras
```

### If you have an issue message me on github or send me an email

## Documentation

### Documentation is under development and should be finished in the next few days

### You can access it [here](https://github.com/MarcelWinterot/nano-keras/wiki/Documentation)

## Roadmap

### Roadmap is now in the Wiki section of nano-keras and not in the source code. You can access it [here](https://github.com/MarcelWinterot/nano-keras/wiki/Roadmap)

## License

### This project is licensed under the MIT License - see the LICENSE file for details
